program popul;
uses crt;

const
  maxpop = 200;
  maxstring = 30;
  dim = 2; {ࠧ୮ ࠭⢠ ᪠}

type
  allele = boolean;
  { -   ⮢ ப }
  chromosome = array[1..maxstring*dim] of allele;
  {⮢ ப }
  fenotype = array[1..dim] of real;

individual = record
  chrom:chromosome;
  { ⨯ = ⮢ ப }
  xy:fenotype; { 䥭⨯ = ᨢ ⢥
  न 窨  ࠭⢥ ᪠ }
  fitness:real; {祭 楫 㭪樨 }
end;
population = array[1..maxpop] of individual;

const
 xymax:real=2.048;
  {ᨢ ᨬ 祭  न 窨  ࠭⢥ ᪠}
 xymin:Real=-2.048;
  {ᨢ  祭  न 窨  ࠭⢥ ᪠}



var
oldpop, newpop, intpop :population;
{ ᥪ 樨 - ,   ஬筠 }
popsize, lchrom, gen, maxgen: integer;
{ 楫 ६}
pcross, pmutation, sumfitness:real;
{ ⢥ ६ }
nmutation, ncross:integer;
{᪨ 楫 }
avg, max, min:real; { ᪨ ⢥ }

{⭮ 楤 }

function random_:real;
begin
  random_ := random(65535)/(65535-1);
end;

function flip(probability:real):boolean;
{뢠 ⪨ - true ᫨ ५}
begin
  if probability = 1.0 then
                       flip := true
                      else
                        flip := (random_ <= probability);
end;

function rnd(low,high:integer):integer;
{砩 롮  low  high }
var
i:integer;
begin
  if low >= high then i := low
                 else begin
                        i := trunc( random_ * (high-low+1) + low);
                        if i > high then i := high;
                      end;
  rnd := i;
end;



{䥩 楤: decode and objfunc }

function objfunc(xy:fenotype):real;
begin
{  objfunc:= int(xy[1])+int(xy[2]);}
{ objfunc:=xy[1]*xy[1];}
 objfunc:=100*sqr(xy[1]*xy[1]-xy[2])+sqr(1-xy[1]);
end;

procedure decode(chrom:chromosome; lbits:integer; var xy:fenotype);
{஢ ப  ᨢ ⢥ न 窨  ࠭⢥ ᪠ - true=1, false=0 }
var
  i,j:integer;
  f, accum, powerof2:real;
begin
  for i:=1 to dim do begin
    accum := 0.0;
    powerof2 := 1;
    f:=1;
    for j := 1+lbits*(i-1) to lbits+lbits*(i-1) do begin
      if chrom[j] then accum := accum + powerof2;
      powerof2 := powerof2 * 2;
      f:=f*2;
    end;
    xy[i] := xymin+(xymax-xymin)*accum/(f-1)
  end;
end;

{ ᪨ 稭: statistics }
procedure statistics(popsize:integer; var max,avg,min,sumfitness:real;var pop:population);
{ ⨪ 樨 }
var j:integer;
begin
  {樠 }
  sumfitness := pop[1].fitness;
  min := pop[1].fitness;
  max := pop[1].fitness;
  {  max, min, sumfitness }
  for j := 2 to popsize do with pop[j] do begin
    sumfitness := sumfitness + fitness;
    { 㬬 祭 㭪樨 ਣ }
    if fitness>max then max := fitness;
    {  祭 max }
    if fitness<min then min := fitness;
    {  祭 min }
  end;
  { । }
  avg := sumfitness/popsize;
end;

{楤 樠樨 initpop}
procedure initpop;
{樠 砫쭮 樨 砩 ࠧ }
var
 j, j1:integer;
begin
  for j := 1 to popsize do with oldpop[j] do begin
    for j1 := 1 to lchrom*dim do chrom[j1] := flip(0.5);
    {᮪ ⪨}
    decode(chrom,lchrom,xy);
    { ஢ ப }
    fitness := objfunc(xy);
    { ᫥ 砫 祭 㭪樨 ਣ }
  end;
end;

{ 3 ᪨ : ⡮ (select), 騢 (crossover),
 樨 (mutation) }

procedure select;
    {楤 롮}
var
  ipick:integer;

  procedure shuffle(var pop:population);
  {楤 ६訢 樨   ⡮}
  var
  i,j:integer;
  ind0:individual;
  begin
    for i := popsize downto 2 do begin
      j:= random(i-1)+1;
      ind0:=pop[i];
      pop[i]:=pop[j];
      pop[j]:=ind0;
    end;
  end;

  function select_1:integer;
  var
   j1,j2,m:integer;
  begin
    if (ipick>popsize) then begin
      shuffle(oldpop);
      ipick:=1
    end;
    j1:=ipick;
    j2:=ipick+1;
    if (oldpop[j2].fitness<oldpop[j1].fitness) then
      m:=j2
    else
      m:=j1;
    ipick:=ipick+2;
    select_1:=m;
  end;

var
  j:integer;
begin
  ipick:=1;
  for j:=1 to popsize do begin
    intpop[j]:=oldpop[select_1];
  end;
  oldpop:=intpop;
end;

procedure mutation(pmutation: real; var nmutation:integer;var mchrom:chromosome);
{ 筠  ⭮ pmutation}
var
  mutate:boolean;
  i: integer;
  aa: allele;
begin
  mutate := flip(pmutation); {롨ࠥ ⭮ 樨 (1%)}
  { Flip the biased coin }
  if mutate then begin
     for i:=1 to maxstring*dim do begin
      if (mchrom[i]=TRUE) then mchrom[i]:=FALSE else mchrom[i]:=TRUE;
     end;
  end else;
  {  樨 }
end;





procedure crossover(var parent1, parent2, child1, child2:chromosome;
      flchrom:integer; var ncross, nmutation, jcross:integer;
var pcross, pmutation:real);
{騢 2 த⥫᪨ ப, १ 頥  2 ப-⮬ }
var
j:integer;
begin
  if flip(pcross) then begin
    { 믮 騢  ⭮ pcross }
    jcross := rnd(1,flchrom-1);
    { । 窨 祭    1  l-1 }
    ncross := ncross + 1;
    {६஢ 稪 騢 }
  end else
    jcross := flchrom;
  {   , 1 to 1 and 2 to 2 }
  for j := 1 to jcross do begin
    child1[j] := parent1[j];
    child2[j] := parent2[j];
  end;
  {  , 1 to 2 and 2 to 1 ]}
  if jcross<>flchrom then
  { ய, ᫨ 窠 騢 ࠢ flchrom--騢  ந室 }
  for j := jcross+1 to flchrom do begin
    child1[j] := parent2[j];
    child2[j] := parent1[j];
  end;
  mutation(pmutation,nmutation,child1);
  mutation(pmutation,nmutation,child2);
end;


{ 楤 ᮧ  : generation }

procedure generation;
{஢     ⡮, 騢  樨 }
{ਬ: ।,     ࠧ}
var
j, mate1, mate2, jcross:integer;
begin
  select;
  j := 1;
  repeat
    {믮 ⡮, 騢       ନ   newpop }
    mate1 := j;
    { 롮 த⥫᪮  }
    mate2 := j+1;
    {騢   -  ⠢  楤 騢 }
    crossover(oldpop[mate1].chrom, oldpop[mate2].chrom,
    newpop[j ].chrom, newpop[j + 1].chrom,
    lchrom*dim, ncross, nmutation, jcross, pcross, pmutation);
    {஢ ப  ᫥ ਣ }
    with newpop[j ] do begin
      decode(chrom, lchrom,xy);
      fitness := objfunc(xy);
    end;
    with newpop[j+1] do begin
      decode(chrom, lchrom,xy);
      fitness := objfunc(xy);
    end;
    j := j + 2;
  until j>popsize
end;

BEGIN {  ணࠬ }
  popsize:=30;              {10,20,30}
  {ࠧ 樨}
  lchrom:=30;
  {᫮ ⮢  n 㥬 ࠬ}
  maxgen:=100;              {30 & 100}
  {ᨬ쭮 ᫮ }
  pmutation:=0.01;
  {⭮ 樨}
  {⭮ 騢}
  pcross:=0.9;
  { 樠  砩 ᥫ }
  randomize;
  clrscr;
  { 樠 稪 }
  nmutation := 0;
  ncross := 0;
  initpop;
  statistics(popsize, max, avg, min, sumfitness, oldpop);
  gen := 0; { ⠭ 稪   0 }
  repeat {  樮 横 }
    gen := gen + 1;
    generation;
    statistics(popsize, max, avg, min, sumfitness, newpop);
    oldpop := newpop;
    {室    }
    writeln('     min= ',min:5:10);
    delay(100);
  until (gen >= maxgen);
  write(' ENTER!!!');
  readln;
END. { End  ணࠬ }
